diff --git a/arch/arm/mach-rmobile/Kconfig.32 b/arch/arm/mach-rmobile/Kconfig.32
index b546e097c34..693a5abba0d 100644
--- a/arch/arm/mach-rmobile/Kconfig.32
+++ b/arch/arm/mach-rmobile/Kconfig.32
@@ -122,7 +122,7 @@ endchoice
 config TMU_TIMER
 	bool
 
-config RMOBILE_EXTRAM_BOOT
+config RENESAS_EXTRAM_BOOT
 	bool "Enable boot from RAM"
 	depends on TARGET_ALT || TARGET_BLANCHE || TARGET_KOELSCH || TARGET_LAGER || TARGET_PORTER || TARGET_SILK || TARGET_STOUT
 
diff --git a/board/renesas/alt/qos.c b/board/renesas/alt/qos.c
index 38dfa647e81..f0cdad4a80f 100644
--- a/board/renesas/alt/qos.c
+++ b/board/renesas/alt/qos.c
@@ -11,7 +11,7 @@
 #include <asm/io.h>
 #include <asm/arch/rmobile.h>
 
-#if defined(CONFIG_ARCH_RMOBILE_EXTRAM_BOOT)
+#if defined(CONFIG_RENESAS_EXTRAM_BOOT)
 /* QoS version 0.311 for ES1 and version 0.321 for ES2 */
 
 enum {
@@ -991,8 +991,8 @@ void qos_init(void)
 	writel(0x00000001, &axi_qos->qosthres2);
 	writel(0x00000001, &axi_qos->qosqon);
 }
-#else /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#else /* CONFIG_RENESAS_EXTRAM_BOOT */
 void qos_init(void)
 {
 }
-#endif /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#endif /* CONFIG_RENESAS_EXTRAM_BOOT */
diff --git a/board/renesas/blanche/qos.c b/board/renesas/blanche/qos.c
index 3134b36a443..d18877ee6db 100644
--- a/board/renesas/blanche/qos.c
+++ b/board/renesas/blanche/qos.c
@@ -10,7 +10,7 @@
 #include <asm/io.h>
 #include <asm/arch/rmobile.h>
 
-#if defined(CONFIG_RMOBILE_EXTRAM_BOOT)
+#if defined(CONFIG_RENESAS_EXTRAM_BOOT)
 enum {
 	DBSC3_00, DBSC3_01, DBSC3_02, DBSC3_03, DBSC3_04,
 	DBSC3_05, DBSC3_06, DBSC3_07, DBSC3_08, DBSC3_09,
@@ -1357,8 +1357,8 @@ void qos_init(void)
 	writel(0x0000F700, CCI_AXI_AX2ADDRMASK);
 
 }
-#else /* CONFIG_RMOBILE_EXTRAM_BOOT */
+#else /* CONFIG_RENESAS_EXTRAM_BOOT */
 void qos_init(void)
 {
 }
-#endif /* CONFIG_RMOBILE_EXTRAM_BOOT */
+#endif /* CONFIG_RENESAS_EXTRAM_BOOT */
diff --git a/board/renesas/gose/qos.c b/board/renesas/gose/qos.c
index 9944df76759..fca30185231 100644
--- a/board/renesas/gose/qos.c
+++ b/board/renesas/gose/qos.c
@@ -11,7 +11,7 @@
 #include <asm/io.h>
 #include <asm/arch/rmobile.h>
 
-#if defined(CONFIG_ARCH_RMOBILE_EXTRAM_BOOT)
+#if defined(CONFIG_RENESAS_EXTRAM_BOOT)
 /* QoS version 0.311 */
 enum {
 	DBSC3_00, DBSC3_01, DBSC3_02, DBSC3_03, DBSC3_04,
@@ -1194,8 +1194,8 @@ void qos_init(void)
 	writel(0x00000001, &axi_qos->qosthres2);
 	writel(0x00000001, &axi_qos->qosqon);
 }
-#else /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#else /* CONFIG_RENESAS_EXTRAM_BOOT */
 void qos_init(void)
 {
 }
-#endif /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#endif /* CONFIG_RENESAS_EXTRAM_BOOT */
diff --git a/board/renesas/koelsch/qos.c b/board/renesas/koelsch/qos.c
index 70cd117ba6b..c947fff75c7 100644
--- a/board/renesas/koelsch/qos.c
+++ b/board/renesas/koelsch/qos.c
@@ -12,7 +12,7 @@
 #include <asm/arch/rmobile.h>
 
 /* QoS version 0.240 for ES1 and version 0.411 for ES2 */
-#if defined(CONFIG_ARCH_RMOBILE_EXTRAM_BOOT)
+#if defined(CONFIG_RENESAS_EXTRAM_BOOT)
 enum {
 	DBSC3_00, DBSC3_01, DBSC3_02, DBSC3_03, DBSC3_04,
 	DBSC3_05, DBSC3_06, DBSC3_07, DBSC3_08, DBSC3_09,
@@ -1382,8 +1382,8 @@ void qos_init(void)
 	writel(0x00000001, &axi_qos->qosthres2);
 	writel(0x00000001, &axi_qos->qosqon);
 }
-#else /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#else /* CONFIG_RENESAS_EXTRAM_BOOT */
 void qos_init(void)
 {
 }
-#endif /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#endif /* CONFIG_RENESAS_EXTRAM_BOOT */
diff --git a/board/renesas/lager/qos.c b/board/renesas/lager/qos.c
index f7eade2ed11..d12fdf0f11f 100644
--- a/board/renesas/lager/qos.c
+++ b/board/renesas/lager/qos.c
@@ -11,7 +11,7 @@
 #include <asm/arch/rmobile.h>
 
 /* QoS version 0.955 for ES1 and version 0.973 for ES2 */
-#if defined(CONFIG_ARCH_RMOBILE_EXTRAM_BOOT)
+#if defined(CONFIG_RENESAS_EXTRAM_BOOT)
 enum {
 	DBSC3_00, DBSC3_01, DBSC3_02, DBSC3_03, DBSC3_04,
 	DBSC3_05, DBSC3_06, DBSC3_07, DBSC3_08, DBSC3_09,
@@ -2424,8 +2424,8 @@ void qos_init(void)
 	else
 		qos_init_es1();
 }
-#else /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#else /* CONFIG_RENESAS_EXTRAM_BOOT */
 void qos_init(void)
 {
 }
-#endif /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#endif /* CONFIG_RENESAS_EXTRAM_BOOT */
diff --git a/board/renesas/porter/qos.c b/board/renesas/porter/qos.c
index e4d8f3dfafe..da6ae9ac559 100644
--- a/board/renesas/porter/qos.c
+++ b/board/renesas/porter/qos.c
@@ -13,7 +13,7 @@
 #include <asm/arch/rmobile.h>
 
 /* QoS version 0.240 for ES1 and version 0.334 for ES2 */
-#if defined(CONFIG_ARCH_RMOBILE_EXTRAM_BOOT)
+#if defined(CONFIG_RENESAS_EXTRAM_BOOT)
 enum {
 	DBSC3_00, DBSC3_01, DBSC3_02, DBSC3_03, DBSC3_04,
 	DBSC3_05, DBSC3_06, DBSC3_07, DBSC3_08, DBSC3_09,
@@ -1303,8 +1303,8 @@ void qos_init(void)
 	writel(0x00000001, &axi_qos->qosthres2);
 	writel(0x00000001, &axi_qos->qosqon);
 }
-#else /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#else /* CONFIG_RENESAS_EXTRAM_BOOT */
 void qos_init(void)
 {
 }
-#endif /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#endif /* CONFIG_RENESAS_EXTRAM_BOOT */
diff --git a/board/renesas/silk/qos.c b/board/renesas/silk/qos.c
index bdd76461b6a..c1d4c612df8 100644
--- a/board/renesas/silk/qos.c
+++ b/board/renesas/silk/qos.c
@@ -12,7 +12,7 @@
 #include <asm/io.h>
 #include <asm/arch/rmobile.h>
 
-#if defined(CONFIG_ARCH_RMOBILE_EXTRAM_BOOT)
+#if defined(CONFIG_RENESAS_EXTRAM_BOOT)
 /* QoS version 0.11 */
 
 enum {
@@ -942,8 +942,8 @@ void qos_init(void)
 	writel(0x00000001, &axi_qos->qosthres2);
 	writel(0x00000001, &axi_qos->qosqon);
 }
-#else /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#else /* CONFIG_RENESAS_EXTRAM_BOOT */
 void qos_init(void)
 {
 }
-#endif /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#endif /* CONFIG_RENESAS_EXTRAM_BOOT */
diff --git a/board/renesas/stout/qos.c b/board/renesas/stout/qos.c
index 8a878123a5d..10f99f340b8 100644
--- a/board/renesas/stout/qos.c
+++ b/board/renesas/stout/qos.c
@@ -13,7 +13,7 @@
 #include <asm/arch/rmobile.h>
 
 /* QoS version 0.955 for ES1 and version 0.973 for ES2 */
-#if defined(CONFIG_ARCH_RMOBILE_EXTRAM_BOOT)
+#if defined(CONFIG_RENESAS_EXTRAM_BOOT)
 enum {
 	DBSC3_00, DBSC3_01, DBSC3_02, DBSC3_03, DBSC3_04,
 	DBSC3_05, DBSC3_06, DBSC3_07, DBSC3_08, DBSC3_09,
@@ -2426,8 +2426,8 @@ void qos_init(void)
 	else
 		qos_init_es1();
 }
-#else /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#else /* CONFIG_RENESAS_EXTRAM_BOOT */
 void qos_init(void)
 {
 }
-#endif /* CONFIG_ARCH_RMOBILE_EXTRAM_BOOT */
+#endif /* CONFIG_RENESAS_EXTRAM_BOOT */